diff --git a/test/validation/classification/classification.h b/test/validation/classification/classification.h
index 6a7e8a5..99dbd65 100644
--- a/test/validation/classification/classification.h
+++ b/test/validation/classification/classification.h
@@ -70,6 +70,12 @@ void classification_test_pmr_terms_cap(void);
 void classification_test_pktio_configure(void);
 void classification_test_pktio_test(void);
 
+void classification_test_pmr_term_tcp_dport(void);
+void classification_test_pmr_term_tcp_sport(void);
+void classification_test_pmr_term_udp_dport(void);
+void classification_test_pmr_term_udp_sport(void);
+void classification_test_pmr_term_ipproto(void);
+
 /* test arrays: */
 extern odp_testinfo_t classification_suite_basic[];
 extern odp_testinfo_t classification_suite[];
diff --git a/test/validation/classification/odp_classification_test_pmr.c b/test/validation/classification/odp_classification_test_pmr.c
index 1502b9a..5a6272e 100644
--- a/test/validation/classification/odp_classification_test_pmr.c
+++ b/test/validation/classification/odp_classification_test_pmr.c
@@ -108,7 +108,7 @@ int classification_suite_pmr_term(void)
 	return retcode;
 }
 
-static void classification_test_pmr_term_tcp_dport(void)
+void classification_test_pmr_term_tcp_dport(void)
 {
 	odp_packet_t pkt;
 	odph_tcphdr_t *tcp;
@@ -197,7 +197,7 @@ static void classification_test_pmr_term_tcp_dport(void)
 	odp_pktio_close(pktio);
 }
 
-static void classification_test_pmr_term_tcp_sport(void)
+void classification_test_pmr_term_tcp_sport(void)
 {
 	odp_packet_t pkt;
 	odph_tcphdr_t *tcp;
@@ -284,7 +284,7 @@ static void classification_test_pmr_term_tcp_sport(void)
 	odp_pktio_close(pktio);
 }
 
-static void classification_test_pmr_term_udp_dport(void)
+void classification_test_pmr_term_udp_dport(void)
 {
 	odp_packet_t pkt;
 	odph_udphdr_t *udp;
@@ -372,7 +372,7 @@ static void classification_test_pmr_term_udp_dport(void)
 	odp_pktio_close(pktio);
 }
 
-static void classification_test_pmr_term_udp_sport(void)
+void classification_test_pmr_term_udp_sport(void)
 {
 	odp_packet_t pkt;
 	odph_udphdr_t *udp;
@@ -459,7 +459,7 @@ static void classification_test_pmr_term_udp_sport(void)
 	odp_pktio_close(pktio);
 }
 
-static void classification_test_pmr_term_ipproto(void)
+void classification_test_pmr_term_ipproto(void)
 {
 	odp_packet_t pkt;
 	uint32_t seqno;
diff --git a/test/validation/pktio/pktio.c b/test/validation/pktio/pktio.c
index 05ddd68..c98361c 100644
--- a/test/validation/pktio/pktio.c
+++ b/test/validation/pktio/pktio.c
@@ -743,7 +743,7 @@ void pktio_test_inq(void)
 	CU_ASSERT(odp_pktio_close(pktio) == 0);
 }
 
-static void pktio_test_start_stop(void)
+void pktio_test_start_stop(void)
 {
 	odp_pktio_t pktio[MAX_NUM_IFACES];
 	odp_packet_t pkt;
@@ -882,7 +882,7 @@ static void pktio_test_start_stop(void)
  * biggest packet we can allocate then the test won't be able to
  * attempt to send packets larger than the MTU, so skip the test.
  */
-static int pktio_check_send_failure(void)
+int pktio_check_send_failure(void)
 {
 	odp_pktio_t pktio_tx;
 	int mtu;
@@ -908,7 +908,7 @@ static int pktio_check_send_failure(void)
 	return (mtu <= ODP_CONFIG_PACKET_BUF_LEN_MAX - 32);
 }
 
-static void pktio_test_send_failure(void)
+void pktio_test_send_failure(void)
 {
 	odp_pktio_t pktio_tx, pktio_rx;
 	odp_packet_t pkt_tbl[TX_BATCH_LEN];
@@ -1043,7 +1043,7 @@ static void pktio_test_send_failure(void)
 	CU_ASSERT(odp_pool_destroy(pkt_pool) == 0);
 }
 
-static void pktio_test_recv_on_wonly(void)
+void pktio_test_recv_on_wonly(void)
 {
 	odp_pktio_t pktio;
 	odp_packet_t pkt;
@@ -1073,7 +1073,7 @@ static void pktio_test_recv_on_wonly(void)
 	CU_ASSERT_FATAL(ret == 0);
 }
 
-static void pktio_test_send_on_ronly(void)
+void pktio_test_send_on_ronly(void)
 {
 	odp_pktio_t pktio;
 	odp_packet_t pkt;
diff --git a/test/validation/pktio/pktio.h b/test/validation/pktio/pktio.h
index f22ff25..58fdbca 100644
--- a/test/validation/pktio/pktio.h
+++ b/test/validation/pktio/pktio.h
@@ -24,6 +24,11 @@ void pktio_test_inq_remdef(void);
 void pktio_test_open(void);
 void pktio_test_lookup(void);
 void pktio_test_inq(void);
+void pktio_test_start_stop(void);
+int pktio_check_send_failure(void);
+void pktio_test_send_failure(void);
+void pktio_test_recv_on_wonly(void);
+void pktio_test_send_on_ronly(void);
 
 /* test arrays: */
 extern odp_testinfo_t pktio_suite[];